#include <dbus/dbus-glib-bindings.h>
#include <ayyi/ayyi_dbus.h>

GQuark          ayyi_msg_error_quark();

void            ayyi_dbus_object_new     (struct _ayyi_action*, const char* name, gboolean from_source, AyyiIdx src_idx, guint32 parent_idx, struct _song_pos* stime, guint64 len, guint32 inset);
void            ayyi_dbus_part_new       (struct _ayyi_action*, const char* name, uint64_t id, gboolean from_source, AyyiIdx src_idx, guint32 parent_idx, struct _song_pos* stime, guint64 len, guint32 inset);
void            ayyi_dbus_object_del     (struct _ayyi_action*, int object_type, uint32_t object_idx);

DBusGProxyCall* dbus_get_prop_string(struct _ayyi_action*, int object_type, int property_type);
DBusGProxyCall* dbus_set_prop_int   (struct _ayyi_action*, int object_type, int property_type, uint32_t object_idx, int val);
DBusGProxyCall* dbus_set_prop_int64 (struct _ayyi_action*, int object_type, int property_type, uint32_t object_idx, int64_t val);
DBusGProxyCall* dbus_set_prop_float (struct _ayyi_action*, int object_type, int property_type, uint32_t object_idx, double val);
DBusGProxyCall* dbus_set_prop_bool  (struct _ayyi_action*, int object_type, int property_type, uint32_t object_idx, gboolean val);
DBusGProxyCall* dbus_set_prop_string(struct _ayyi_action*, int object_type, int property_type, AyyiIdx, const char* val);
DBusGProxyCall* dbus_set_prop_f_pair(struct _ayyi_action*, int object_type, int property_type, GArray* object_idx, double val1, double val2);

void            dbus_undo           (AyyiService*, int n);

GArray*         ayyi_index_array_new(guint, guint, guint);
