/*

Ayyi uses 2 time formats; one sample based and one musical-time based.

The musical formats are high precision in order to allow conversion to and from other formats.

*/
#ifdef __cplusplus
extern "C" {
#endif
#include "glib.h"

#define AYYI_MU_PER_SUB 11025
#define AYYI_SUBS_PER_BEAT 3840
#define TICKS_PER_SUBBEAT 384     // there seems to be confusion over whether this is 960 or 384!
#define BBST_FORMAT "%03i:%02i:%02i:%03i"
#define AYYI_BBST_MAX 16
#define AYYI_MAX_BEATS 6400

void           ayyi_pos2bbst          (AyyiSongPos*, char* bbst);
int64_t        ayyi_pos2mu            (AyyiSongPos*);
void           ayyi_pos_add_mu        (AyyiSongPos*, uint64_t mu);
gboolean       ayyi_pos_is_valid      (AyyiSongPos*);
void           ayyi_samples2pos       (uint32_t samples, AyyiSongPos*);
uint32_t       ayyi_pos2samples       (AyyiSongPos*);
long long      ayyi_samples2mu        (unsigned long long samples);
long long      ayyi_mu2samples        (int64_t mu);
void           ayyi_mu2pos            (uint64_t len, AyyiSongPos*);
uint64_t       ayyi_beats2mu          (double beats);
long long      ayyi_beats2samples     (int beats);
long long      ayyi_beats2samples_float (float beats);
gboolean       ayyi_pos_cmp           (const AyyiSongPos*, const AyyiSongPos*);
void           ayyi_pos_add           (AyyiSongPos*, const AyyiSongPos*);
void           ayyi_samples2bbst      (uint64_t samples, char* str);

#ifdef __cplusplus
}
#endif
