#ifndef __ayyi_typedefs_h__
#define __ayyi_typedefs_h__

#include <stdint.h>
#include <glib.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _ayyi_server         AyyiServer;
typedef struct _ayyi_client         AyyiClient;
typedef struct _ayyi_shm_seg        AyyiShmSeg;
typedef struct _shm_song            AyyiShmSong;
typedef struct _shm_seg_mixer       AyyiShmMixer;

typedef struct _ayyi_action         AyyiAction;
typedef struct _ayyi_obj_idx        AyyiObjIdx;
typedef enum   _ayyi_op_type        AyyiOpType;
typedef enum   _ayyi_prop_type      AyyiPropType;
typedef struct _ident               AyyiIdent;
typedef struct _service             AyyiService;
typedef struct _ardourd_service     AyyiSongService;
typedef struct _ardourd_mixer_service AyyiMixerService;
typedef struct _shm_seg             shm_seg;
typedef enum   _seg_type            SegType;
typedef struct _song_pos            AyyiSongPos;
typedef struct _container           AyyiContainer;
typedef struct _block               block;
typedef struct _block               AyyiBlock;
typedef struct _ayyi_base_item      AyyiItem;
typedef struct _route_shared        AyyiTrack;
typedef struct _ayyi_channel        AyyiChannel;
typedef struct _region_base_shared  AyyiRegionBase;
typedef struct _ayyi_audio_region   AyyiRegion;
typedef struct _ayyi_audio_region   AyyiAudioRegion;
typedef struct _midi_region_shared  AyyiMidiRegion;
typedef struct _filesource_shared   AyyiFilesource;
typedef struct _playlist_shared     AyyiPlaylist;
typedef struct _ayyi_connection     AyyiConnection;
typedef struct _midi_track_shared   AyyiMidiTrack;
typedef struct _ayyi_aux            AyyiAux;
typedef struct _ayyi_control        AyyiControl;
typedef struct _plugin_shared       AyyiPlugin;
typedef struct _midi_note           MidiNote;
typedef struct _launch_info         AyyiLaunchInfo;
typedef struct _handler_data        HandlerData;
typedef struct _shm_callback_data   AyyiShmCallbackData;

typedef int                         AyyiIdx;
typedef uint32_t                    AyyiObjType;
typedef uint64_t                    AyyiId;

typedef gboolean (*AyyiShmCallback) (struct _shm_seg*);
typedef void   (*AyyiCallbackX)     ();
typedef void   (*AyyiCallback)      (gpointer);
typedef void   (*AyyiFinish)        (AyyiIdent, gpointer);
typedef void   (*AyyiHandler2)      (GError*, gpointer);
typedef void   (*AyyiHandler)       (AyyiIdent, GError**, gpointer);
typedef void   (*AyyiPropHandler)   (AyyiIdent, GError**, AyyiPropType, gpointer);
typedef void   (*AyyiValHandler)    (AyyiIdent, GError**, double, gpointer);
//typedef void   (*AyyiHandler6)      (AyyiIdent, gpointer, GError**);
typedef void   (*AyyiActionCallback)(AyyiAction*);

#ifndef true
#define true  1
#define false 0
#endif

#endif // __ayyi_typedefs_h__

#ifdef __cplusplus
}
#endif
