#ifndef __am_time_h__
#define __am_time_h__
#include "ayyi/ayyi_time.h"

#define SUBS_PER_BEAT 4           // a gui subbeat is a 16th
#define TICKS_PER_BEAT (4 * TICKS_PER_SUBBEAT)
#define MU_PER_TICK (AYYI_MU_PER_SUB * AYYI_SUBS_PER_BEAT / TICKS_PER_BEAT)
#define MU_PER_BEAT (AYYI_MU_PER_SUB * AYYI_SUBS_PER_BEAT)

#ifdef __am_time_c__
const uint64_t    mu_per_beat = (AYYI_MU_PER_SUB * AYYI_SUBS_PER_BEAT);
const uint64_t    mu_per_sub  = (AYYI_MU_PER_SUB * AYYI_SUBS_PER_BEAT) / 4;
const uint32_t    ticks_per_beat = 4 * TICKS_PER_SUBBEAT;
#endif

int            pos_bar              (GPos*);
int            pos_beat             (GPos*);

void           pos2bbst             (GPos*, char* str);
void           pos2bbst0            (GPos*, char* str);
void           pos2bbs              (GPos*, char* str);
uint64_t       pos2mu               (GPos*);
double         pos2beats            (GPos*);
gboolean       songpos_ayyi2gui     (GPos*, AyyiSongPos*);
void           songpos_gui2ayyi     (AyyiSongPos*, GPos*);
gboolean       gpos_is_valid        (GPos*);
gboolean       gpos_is_empty        (GPos*);

gboolean       pos_is_before        (const GPos* pos1, const GPos* pos2);
gboolean       pos_is_after         (const GPos* pos1, const GPos* pos2);

void           mu2bbst              (uint64_t len, char* str);
void           mu2pos               (uint64_t len, GPos* pos);
void           samples2pos          (uint64_t samples, GPos*);
unsigned       pos2samples          (GPos*);

void           pos_set              (GPos*, int beat, uint16_t sub, uint16_t tick);
gboolean       pos_copy             (GPos*, const GPos*);
void           pos_add              (GPos*, const GPos*);
void           pos_subtract         (GPos*, const GPos*);
void           pos_divide           (GPos*, int);
int            pos_diff             (const GPos* pos1, const GPos* pos2);
gboolean       gpos_cmp             (const GPos*, const GPos*);
void           pos_min              (GPos*, const GPos*);
void           pos_max              (GPos*, const GPos*);

long           samples2beats        (uint64_t samples);
double         samples2secs         (uint64_t samples);
uint64_t       bars2mu              (float bars);

gboolean       bbst2pos             (const char* bbst, GPos*);

gboolean       bbst_increment       (char*);
gboolean       bbst_decrement       (char*);

void           am_q_init            ();
gboolean       q_to_nearest         (GPos*, QMap*);
void           q_to_prev            (GPos*, QMap*);
void           q_to_next            (GPos*, QMap*);
void           q_to_prev_or_current (GPos*, QMap*);
void           q_to_next_or_current (GPos*, QMap*);

void           am_snap_to_next      (GPos*);
void           am_snap              (GPos*);

#endif //__am_time_h__
