#ifndef __am_utils_h__
#define __am_utils_h__

#define list_clear(L) g_list_free(L); L = NULL;

//see also ayyi_handler_simple
#define DO_RESPONSE(TYPE) \
	HandlerData* d = a->app_data; \
	if(d){ \
		AyyiIdent id = {TYPE, a->ret.idx}; \
		call(d->callback, id, &a->ret.error, d->user_data); \
	}


float       am_db2gain               (float);
float       am_gain2db               (float);

char*       replace                  (const char* string, char* oldpiece, char* newpiece);
void        replace2                 (char* string, char* oldpiece, char* newpiece);
gchar*      str_replace              (const gchar* string, const gchar* search, const gchar* replace);
void        escape_for_menu          (char*);

gchar*      am_audio_path_get_full   (const char* path);

void        format_time_samples      (char* formatted, uint32_t samples);
char*       am_format_channel_width  (unsigned width);

gboolean    file_exists              (const char* path);
void        filename_change_extension(char* path, const char* extn);
void        filename_get_extension   (const char* path, char* extn);
void        filename_remove_extension(const char* filename, char* truncated);
char*       filename_get_stereo      (const char*);
gboolean    am_file_is_newer         (const char* file1, const char* file2);
gboolean    file_delete_recursive    (const char*);

gboolean    am_audiofile_is_readable (const char* filename);

typedef void (*Fn) (gpointer);       //TODO
void        am_do_series_            (Fn functions[], int n_functions, AyyiCallback);
void        am_do_series             (Fn*, AyyiCallback, gpointer);

typedef struct _do_closure DoClosure;
struct _do_closure {
	int          i;
	Fn*          functions;
	AyyiCallback finished;
	gpointer     user_data;
	Fn           next;
};


#endif //__am_utils_h__
