/*


*/
#define __ayyi_private__
#include "config.h"
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <getopt.h>
#include <time.h>
#include <unistd.h>
#include <signal.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <signal.h>
#include <glib.h>
#include <jack/jack.h>
#include "model/ayyi_model.h"
#include "test/am_common.h"

//void              app_on_shm_complete();

TestFn
	test_delete_audio_part,
	test_add_delete_stress_audio_part,
	test_split_audio_part;

#define STOP false;
char       current_test_name[64];
gpointer   tests[] = {
	//test_delete_audio_part,
	//test_split_audio_part,
	test_add_delete_stress_audio_part,
};

#define FINISH_TEST_TIMER_STOP \
	test_finished = true; \
	passed = true; \
	test_finished_(); \
	return TIMER_STOP;

#define assert(A, B, ...) \
	{bool __ok_ = (bool)A; \
	{if(!__ok_) gerr(B, ##__VA_ARGS__); } \
	{if(!__ok_) FAIL_TEST("assertion failed") }}

#define assert_and_stop(A, B, ...) \
	{bool __ok_ = (bool)A; \
	{if(!__ok_) gerr(B, ##__VA_ARGS__); } \
	{if(!__ok_) FAIL_TEST_TIMER("assertion failed") }}


#include "modules.c"


/*
void
log_handler(const gchar* log_domain, GLogLevelFlags log_level, const gchar* message, gpointer user_data)
{
  switch(log_level){
    case G_LOG_LEVEL_CRITICAL:
      printf("%s %s\n", ayyi_err, message);
      break;
    case G_LOG_LEVEL_WARNING:
      printf("%s %s\n", ayyi_warn, message);
      break;
    default:
      printf("log_handler(): level=%i %s\n", log_level, message);
      break;
  }
}
*/


int
main (int argc, char *argv[])
{
	am_test_init(tests, G_N_ELEMENTS(tests));

	app.dbus = true; //TODO
	am__connect_all(app_on_all_shm, NULL);
	g_main_loop_run (main_loop = g_main_loop_new (NULL, 0));

	return EXIT_SUCCESS;
}


void
test_delete_audio_part()
{
	START_TEST;

	static int n_parts; n_parts = g_list_length(song->parts->list);
	AMPart* part = song->parts->list->data;

	void test_delete_audio_part_done(AyyiIdent id, GError** error, gpointer user_data)
	{
		dbg(0, "n_parts=%i-->%i", n_parts, g_list_length(song->parts->list));
		if(n_parts - 1 != g_list_length(song->parts->list)) FAIL_TEST("");
		FINISH_TEST;
	}

	am_song__remove_part(part, test_delete_audio_part_done, NULL);
}


void
test_add_delete_stress_audio_part()
{
	//adds and deletes parts randomly.
	//TODO only 1 action is done simultaneously. We should try more.

	START_TEST;
	static int n_ops = 10;
	static int n_added = 0;
	static int n_deleted = 0;

	struct _data
	{
		void (*on_add)();
		void (*on_delete)();
	};

	void delete_done(gpointer _user_data)
	{
		PF;
		struct _data* data = (struct _data*)_user_data;
		n_deleted++;
		if(++step >= n_ops){
			printf("n_added=%i n_deleted=%i\n", n_added, n_deleted);

			//wait for cleanup
			gboolean f(gpointer data)
			{
				FINISH_TEST_TIMER_STOP;
				return TIMER_STOP;
			}
			g_timeout_add(10100, f, NULL);
		}

		if(get_random_boolean() && g_list_length(song->parts->list)){
			int n = get_random_int(g_list_length(song->parts->list));
			AMPart* part = g_list_nth_data(song->parts->list, n);
			module__delete_audio_part(data->on_delete, part, data);
		}else{
			module__add_audio_part(data->on_add, data);
		}
	}

	void add_done(AyyiIdent obj, gpointer _user_data)
	{
		dbg(0, "******** step=%i", step);
		n_added++;
		struct _data* data = (struct _data*)_user_data;
		if(++step >= n_ops){
			printf("n_added=%i n_deleted=%i\n", n_added, n_deleted);
			FINISH_TEST;
		}

		if(get_random_boolean() && g_list_length(song->parts->list)){
			int n = get_random_int(g_list_length(song->parts->list));
			AMPart* part = g_list_nth_data(song->parts->list, n);
			module__delete_audio_part(data->on_delete, part, data);
		}else{
			module__add_audio_part(data->on_add, data);
		}
	}

	struct _data* user_data = g_new0(struct _data, 1);
	user_data->on_add = add_done;
	user_data->on_delete = delete_done;


	dbg(0, "finish=%p", add_done);
	module__add_audio_part(add_done, user_data);

	return;
}


void
test_split_audio_part()
{
	START_TEST;

	static int n_parts; n_parts = g_list_length(song->parts->list);

	void test_split_audio_part_done(AyyiIdent id, GError** error, gpointer user_data)
	{
		//TODO wait until the two new parts have been created.
		dbg(0, "!!!!!!!!!! n_parts=%i-->%i", n_parts, g_list_length(song->parts->list));
		//if(n_parts - 1 != g_list_length(song->parts->list)) FAIL_TEST;
		FINISH_TEST;
	}

	AMPart* part = song->parts->list->data;
	GPos pos = part->length;
	pos_divide(&pos, 2);
	pos_add(&pos, &part->start);
	AyyiSongPos p;
	songpos_gui2ayyi(&p, &pos);
	am_part__split(part, &p, test_split_audio_part_done, NULL);

	return;
}


#if 0
void
app_on_shm_complete()
{
	if(ayyi.service->song->version != AYYI_SHM_VERSION){
		gwarn ("wrong shm version: %i - should be %i", ayyi.service->song->version, AYYI_SHM_VERSION);
		//app.set_state(APP_STATE_ABORT);
		return;
	}

	ayyi.got_shm = 1;

	log_print(LOG_OK, "connected to server");

	printf("parts: %i(%i)\n", g_list_length(song->parts->list), ayyi_song_container_count_items(&ayyi.service->song->audio_regions));

	next_test();
}
#endif


void
test_never()
{
	test_delete_audio_part();
	module__add_midi_track(0, 0);
	module__add_midi_part(0, 0);
	module__delete_parts_by_audio_file(0, NULL, 0);
	module__delete_audio_part(0, 0, 0);
	module__load_song_with_delay(0, 0, 0);
	module__delete_all_audio_files(0, 0);
}


